link

A named channel for sending or receiving messages. More...

`#include <link.hpp>`

Inheritance diagram for link:
[legend]
Collaboration diagram for link:
[legend]

## Public Member Functions

| link ()
| Create an empty link.
bool | uninitialized () const
| True if the local end is uninitialized.
bool | active () const
| True if the local end is active.
bool | closed () const
| True if the local and remote ends are closed.
class error_condition | error () const
| Get the error condition of the remote endpoint.
void | close ()
| Close the endpoint. More...
void | close (const error_condition &)
| Close the endpoint with an error condition. More...
void | detach ()
| Suspend the link without closing it. More...
int | credit () const
| Credit available on the link.
bool | draining ()
| Unsettled API - True for a receiver if a drain cycle has been started and the corresponding `on_receiver_drain_finish` event is still pending. More...
std::string | name () const
| Get the link name.
class container & | container () const
| The container for this link.
class work_queue & | work_queue () const
| Get the work_queue for the link.
class connection | connection () const
| The connection that owns this link.
class session | session () const
| The session that owns this link.

## Detailed Description

A named channel for sending or receiving messages.

It is the base class for sender and receiver.

## Member Function Documentation

## close() [1/2]

void close | ( |  | ) |

virtual

Close the endpoint.

See also
  endpoint_lifecycle

Implements endpoint.

Examples
  direct_recv.cpp, helloworld.cpp, service_bus.cpp, and simple_recv.cpp.

## close() [2/2]

void close | ( | const error_condition & |  | ) |

virtual

Close the endpoint with an error condition.

See also
  endpoint_lifecycle

Implements endpoint.

## detach()

void detach | ( |  | ) |

Suspend the link without closing it.

A suspended link may be reopened with the same or different link options if supported by the peer. A suspended durable subscription becomes inactive without cancelling it.

## draining()

bool draining | ( |  | ) |

Unsettled API - True for a receiver if a drain cycle has been started and the corresponding `on_receiver_drain_finish` event is still pending.

True for a sender if the receiver has requested a drain of credit and the sender has unused credit.

See also
  receiver::drain.

The documentation for this class was generated from the following file:

- proton/link.hpp